/*
 * Copyright 2009-2013 Aarhus University
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dk.brics.tajs.analysis;

import dk.brics.tajs.lattice.CallEdge;
import dk.brics.tajs.monitoring.IAnalysisMonitoring;
import dk.brics.tajs.monitoring.Monitoring;
import dk.brics.tajs.solver.GenericSolver;
import dk.brics.tajs.solver.SolverSynchronizer;

/**
 * Fixpoint solver.
 */
public final class Solver extends GenericSolver<State,Context,CallEdge<State>,IAnalysisMonitoring<State, Context, CallEdge<State>>,Analysis> {

	/**
	 * Constructs a new solver.
	 */
	public Solver(Analysis analysis, SolverSynchronizer sync) {
		super(analysis, sync);
	}
}
