/*
 * Copyright 2009-2013 Aarhus University
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dk.brics.tajs.analysis.dom.view;

import dk.brics.tajs.analysis.State;
import dk.brics.tajs.analysis.dom.DOMWindow;
import dk.brics.tajs.analysis.dom.core.DOMNode;
import dk.brics.tajs.lattice.Value;

import static dk.brics.tajs.analysis.dom.DOMFunctions.createDOMProperty;

/**
 * The DocumentView interface is implemented by Document objects in DOM implementations supporting DOM Views.
 * It provides an attribute to retrieve the default view of a document.
 */
public class DocumentView {

    public static void build(State s) {
        // DocumentView has no native object... see class comment.

        /*
         * Properties.
         */
        createDOMProperty(s, DOMNode.INSTANCES, "defaultView", Value.makeObject(DOMWindow.WINDOW).setReadOnly());
    }
}
