package dk.brics.tajs.analysis.nativeobjects.concrete;

import java.util.ArrayList;

public class ConcreteArray implements ConcreteValue {
    private final ArrayList<ConcreteValue> array;

    public ConcreteArray(ArrayList<ConcreteValue> array) {
        this.array = array;
    }

    @Override
    public String toSourceCode() {
        StringBuilder sb = new StringBuilder();
        sb.append("[");
        boolean first = true;
        for (ConcreteValue argument : array) {
            if (!first) {
                sb.append(", ");
            }
            first = false;
            if (argument instanceof ConcreteNullOrUndefined) {
                sb.append(argument.toString());
            } else {
                sb.append(argument.toSourceCode());
            }
        }
        sb.append("]");
        return sb.toString();
    }

    @Override
    public String toString() {
        return toSourceCode();
    }

    @Override
    public <T> T accept(ConcreteValueVisitor<T> v) {
        return v.visit(this);
    }

    public int getLength() {
        return array.size();
    }

    public ConcreteValue get(int i) {
        return array.get(i);
    }
}
