package dk.brics.tajs.analysis.nativeobjects.concrete;

public class ConcreteNumber implements PrimitiveConcreteValue {
    private final double number;

    public ConcreteNumber(Double number) {
        this.number = number;
    }

    @Override
    public String toSourceCode() {
        return String.format("%f", number);
    }

    @Override
    public <T> T accept(ConcreteValueVisitor<T> v) {
        return v.visit(this);
    }

    public double getNumber() {
        return number;
    }
}
