package dk.brics.tajs.analysis.nativeobjects.concrete;

public class ConcreteString implements PrimitiveConcreteValue {
    private final String string;

    public ConcreteString(String string) {
        this.string = string;
    }

    @Override
    public String toSourceCode() {
        return String.format("\"%s\"", string.replace("\"", "\\\""));
    }

    @Override
    public <T> T accept(ConcreteValueVisitor<T> v) {
        return v.visit(this);
    }

    public String getString() {
        return string;
    }
}
