package dk.brics.tajs.csi;

import dk.brics.tajs.analysis.ContextArguments;
import dk.brics.tajs.analysis.FunctionCalls;
import dk.brics.tajs.analysis.State;
import dk.brics.tajs.flowgraph.Function;
import dk.brics.tajs.lattice.Value;
import dk.brics.tajs.solver.GenericSolver;

import java.util.List;

import static dk.brics.tajs.util.Collections.newList;

public class AllParamContextCreator implements CallEntryContextCreator {
    @Override
    public ContextArguments getContextArguments(Function function, FunctionCalls.CallInfo call, State state, GenericSolver.SolverInterface c) {
        if (call.isUnknownNumberOfArgs()) {
            return new ContextArguments(call.getUnknownArg());
        }
        List<Value> arguments = newList();
        for (int i = 0; i < call.getNumberOfArgs(); i++) {
            Value argument = call.getArg(i);
            arguments.add(argument);
        }
        return new ContextArguments(function.getParameterNames(), arguments);
    }

}
