package dk.brics.tajs.csi;

import dk.brics.tajs.analysis.Solver;
import dk.brics.tajs.flowgraph.Function;

public class CompositeCSI implements ContextSensitivityInferer {
    private final ContextSensitivityInferer csi1;
    private final ContextSensitivityInferer csi2;

    public CompositeCSI(ContextSensitivityInferer csi1, ContextSensitivityInferer csi2) {
        this.csi1 = csi1;
        this.csi2 = csi2;
    }

    @Override
    public void inferLocals(Function f, Solver.SolverInterface c) {
        csi1.inferLocals(f, c);
        csi2.inferLocals(f, c);
    }
}
