package dk.brics.tajs.csi;

import dk.brics.tajs.analysis.ContextArguments;
import dk.brics.tajs.flowgraph.Function;
import dk.brics.tajs.flowgraph.jsnodes.CallNode;
import dk.brics.tajs.flowgraph.jsnodes.NewObjectNode;
import dk.brics.tajs.flowgraph.jsnodes.ReadVariableNode;

public interface LiteralContextSensitivityStrategy {
    void registerBeginObjectLiteral(NewObjectNode node);

    void registerEndObjectLiteral(NewObjectNode node);

    void registerVariableRead(Function function, ReadVariableNode readVariableNode);

    boolean shoudArrayBeSensitive(CallNode node, ContextArguments arguments);

    boolean shoudObjectBeSensitive(NewObjectNode node, ContextArguments arguments);

    void registerBeginForIn(Function function);

    void registerEndForIn(Function function);
}
