/*
 * Copyright 2009-2013 Aarhus University
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dk.brics.tajs.lattice;

import dk.brics.tajs.solver.ICallEdge;

/**
 * Information stored at an edge in a call graph.
 */
public class CallEdge<BlockStateType extends BlockState<?,?,?>> implements ICallEdge<BlockStateType> {

	private BlockStateType state;
	
	/**
	 * Constructs a new edge object.
	 */
	public CallEdge(BlockStateType state) {
		this.state = state;
	}

	@Override
	public BlockStateType getState() {
		return state;
	}

	@Override
	public void setState(BlockStateType s) {
		state = s;
	}
}
