package dk.brics.tajs.monitoring;

import dk.brics.tajs.Main;
import dk.brics.tajs.analysis.Context;
import dk.brics.tajs.analysis.FunctionCalls;
import dk.brics.tajs.analysis.State;
import dk.brics.tajs.flowgraph.*;
import dk.brics.tajs.flowgraph.jsnodes.*;
import dk.brics.tajs.lattice.*;
import dk.brics.tajs.monitoring.IAnalysisMonitoring;
import dk.brics.tajs.solver.CallGraph;
import dk.brics.tajs.solver.IBlockState;
import dk.brics.tajs.solver.IContext;
import dk.brics.tajs.solver.Message;

import java.util.Collection;
import java.util.Set;

/**
 * Default, empty, implementation of IAnalysisMonitoring.
 * Enables easy creation of classes which only needs to override a few methods.
 */
public class DefaultIAnalysisMonitoring<
        BlockStateType extends BlockState<BlockStateType, ContextType, CallEdgeType>,
        ContextType extends IContext<ContextType>,
        CallEdgeType extends CallEdge<BlockStateType>> implements IAnalysisMonitoring<BlockStateType, ContextType, CallEdgeType> {

    @Override
    public void registerFlowgraph(FlowGraph fg) {

    }

    @Override
    public void setFinalAnalysisState(State finalState) {

    }

    @Override
    public void setFinalCallGraph(CallGraph<State, Context, CallEdge<State>> callGraph) {

    }

    @Override
    public void visitHostFunctionCall(AbstractNode sourceNode, HostObject hostobject, FunctionCalls.CallInfo call, BlockStateType state) {

    }

    @Override
    public void visitNodeTransfer(AbstractNode n) {

    }

    @Override
    public void visitBlockTransfer(BasicBlock b, ContextType context) {

    }

    @Override
    public void visitNewFlow(BasicBlock b, IContext<?> c, IBlockState<?, ?, ?> s, String diff, String info) {

    }

    @Override
    public void visitUnknownValueResolve(boolean partial, boolean scanning) {

    }

    @Override
    public void visitRecoveryGraph(int size) {

    }

    @Override
    public void visitFunction(Function f, Collection<BlockStateType> entry_states) {

    }

    @Override
    public void visitReachableNode(AbstractNode n) {

    }

    @Override
    public void visitJoin() {

    }

    @Override
    public void beginScanPhase(FlowGraph fg) {

    }

    @Override
    public void endScanPhase(FlowGraph fg) {

    }

    @Override
    public void visitNonFixedPropertyRead(ReadPropertyNode n, Value propertyval) {

    }

    @Override
    public void beginPhase(Main.Phase phase) {

    }

    @Override
    public void endPhase(Main.Phase phase) {

    }

    @Override
    public void visitReadNonThisVariable(ReadVariableNode n, Value v) {

    }

    @Override
    public void visitReadThis(ReadVariableNode n, Value v, BlockStateType state, ObjectLabel global_obj) {

    }

    @Override
    public void visitReadVariable(ReadVariableNode n, Value v, BlockStateType state) {

    }

    @Override
    public void visitWriteVariable(WriteVariableNode n, Value v, BlockStateType state) {

    }

    @Override
    public void visitIf(IfNode n, Value v) {

    }

    @Override
    public void visitInstanceof(AbstractNode n, boolean maybe_v2_non_function, boolean maybe_v2_function, boolean maybe_v2_prototype_primitive, boolean maybe_v2_prototype_nonprimitive) {

    }

    @Override
    public void visitIn(AbstractNode n, boolean maybe_v2_object, boolean maybe_v2_nonobject) {

    }

    @Override
    public void visitPropertyAccess(Node n, Value baseval) {

    }

    @Override
    public void visitReadProperty(ReadPropertyNode n, Set<ObjectLabel> objlabels, Str propertystr, boolean maybe, BlockStateType state) {

    }

    @Override
    public void visitPropertyRead(Node n, Set<ObjectLabel> objs, Str propertystr, BlockStateType state, boolean check_unknown) {

    }

    @Override
    public void visitPropertyWrite(Node n, Set<ObjectLabel> objs, Str propertystr) {

    }

    @Override
    public void visitUserFunctionCall(Function f, AbstractNode call, boolean constructor) {

    }

    @Override
    public void visitCall(AbstractNode n, boolean maybe_non_function, boolean maybe_function) {

    }

    @Override
    public void visitEvalCall(AbstractNode n, Value v) {

    }

    @Override
    public void visitInnerHTMLWrite(Node n, Value v) {

    }

    @Override
    public void visitNativeFunctionCall(AbstractNode n, HostObject hostobject, boolean num_actuals_unknown, int num_actuals, int min, int max) {

    }

    @Override
    public void visitRead(Node n, Value v, BlockStateType state) {

    }

    @Override
    public void visitVariableAsRead(ReadVariableNode n, Value v, BlockStateType state) {

    }

    @Override
    public void generateUnreachableMap() {

    }

    @Override
    public void visitVariableOrProperty(String var, SourceLocation loc, Value value, IContext context, State state) {

    }

    @Override
    public void addMessageInfo(AbstractNode n, Message.Severity severity, String msg) {

    }

    @Override
    public void addMessage(AbstractNode n, Message.Severity severity, String msg) {

    }

    @Override
    public void addMessage(AbstractNode n, Message.Severity severity, String key, String msg) {

    }

    @Override
    public void visitPostBlockTransfer(BasicBlock b, BlockStateType state) {

    }
}
