package dk.brics.tajs.monitoring;

import dk.brics.tajs.lattice.BlockState;
import dk.brics.tajs.lattice.CallEdge;
import dk.brics.tajs.solver.IContext;

/**
 * Tagging interface for monitors which does <emph>not</emph> affect the analysis.
 * (such monitors should only be used during the scan phase)
 * <p/>
 * In particular, every monitor which use the following methods should <empth>not</empth> implement this interface:
 * (incomplete list)
 * <p/>
 * <code>UnknownValueResolver.getRealValue(v, state);</code>
 */
public interface IAnalysisSideEffectFreeMonitoring<
        BlockStateType extends BlockState<BlockStateType, ContextType, CallEdgeType>,
        ContextType extends IContext<ContextType>,
        CallEdgeType extends CallEdge<BlockStateType>> extends IAnalysisMonitoring<BlockStateType, ContextType, CallEdgeType> {
}
