/*
 * Copyright 2009-2013 Aarhus University
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package dk.brics.tajs.solver;

import dk.brics.tajs.flowgraph.BasicBlock;
import org.jdom.Document;

/**
 * Interface for initial state builder classes.
 */
public interface IInitialStateBuilder<BlockStateType extends IBlockState<BlockStateType, ContextType, CallEdgeType>,
                                      ContextType extends IContext<ContextType>,
                                      CallEdgeType extends ICallEdge<BlockStateType>> {

	/**
	 * Builds the initial state.
	 */
	public void addInitialState(BasicBlock global_entry_block, GenericSolver<BlockStateType, ContextType, CallEdgeType, ?, ?>.SolverInterface c, Document document);
}
